//
//  STTwitterStreamer.h
//  STTwitterStreamer
//
//  Created by Sebastien Thiebaud on 1/19/13.
//  Copyright (c) 2013 Sebastien Thiebaud. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <Accounts/Accounts.h>
#import <Social/Social.h>

@protocol STTwitterStreamerDelegate <NSObject>

@required
- (void)multipleAccountsConfigured:(NSArray *)accounts;
- (void)streamAvailable;
- (void)newTweet:(NSDictionary *)informations;
- (void)deleteTweet:(NSDictionary *)informations atIndex:(int)index;

@optional
- (void)noAccountConfigured;
- (void)streamStopped;

@end

@interface STTwitterStreamer : NSObject <NSURLConnectionDataDelegate>
{
    ACAccountStore *_accountStore;
    ACAccount *_account;
    
    NSURLConnection *_connection;
    
    NSArray *_friends;
}

+ (STTwitterStreamer *)stream;

- (void)settingUpWithAccount:(ACAccount *)account;
- (void)start;
- (void)stop;

@property (nonatomic, retain) id<STTwitterStreamerDelegate> delegate;
@property (nonatomic, readonly) NSMutableArray *tweets;

@end
